/*
 * $RCSfile: error.c,v $
 * $Date: 2005/05/28 14:43:35 $ - $Revision: 1.3 $
 *
 * This file is distributed as a part of MMSRIP ( MMS Ripper ).
 * Copyright (c) 2005 Nicolas BENOIT
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2, or (at your option) any
 * later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */


#define _GNU_SOURCE

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include "error.h"
#include "common.h"


/*
 * Prints A Warning
 */
void
warning ( const char *prod,
          const char *format,
          ... )
{
  char *message, *str;
  va_list ap;

  if ( format == NULL )
    return;

  str = ( char * ) malloc ( ERROR_MSG_LEN );
  message = ( char * ) malloc ( ERROR_MSG_LEN );

  va_start ( ap, format );
  vsnprintf ( message, ERROR_MSG_LEN, format, ap );
  va_end ( ap );

  if ( prod != NULL )
    snprintf ( str, ERROR_MSG_LEN, "warning in %s(): %s.\n", prod, message );
  else
    snprintf ( str, ERROR_MSG_LEN, "warning: %s.\n", message);

  fprintf ( stderr, str );
  free ( message );
  free ( str );
}


/*
 * Prints An Error Message
 */
void
error ( const char *prod,
        const char *format,
        ... )
{
  char *message, *str;
  va_list ap;

  if ( format == NULL )
    return;

  str = ( char * ) malloc ( ERROR_MSG_LEN );
  message = ( char * ) malloc ( ERROR_MSG_LEN );

  va_start ( ap, format );
  vsnprintf ( message, ERROR_MSG_LEN, format, ap );
  va_end ( ap );

  if ( prod != NULL )
    snprintf ( str, ERROR_MSG_LEN, "error in %s(): %s.\n", prod, message );
  else
    snprintf ( str, ERROR_MSG_LEN, "error: %s.\n", message);

  fprintf ( stderr, str );
  free ( message );
  free ( str );
}
